(function() {
"use strict";	
/*
* 
*
* 
* 
*	
*	
*	
*	
*	
* 	
*	
*
*/

//   !!!! - CHECK IF THERE IS A BLOCK (look for pageClassName), if not, bail  !!!!!! 

// Define variables 
	var ssqInput = {};
	var ssqCalc;
	var	scrollsequenceCanvasElement;
	var	context;
	var	arrayOfImageObjects;
	var	cur;
//ssqInput.debugSs = '1';

function ssqInputFromPages(pageClassName){ // Get Input from UI/HTML  (different for CPT and Block)
	ssqInput.page = [];
	ssqInput.pageElements = document.querySelectorAll(pageClassName);
	ssqInput.pageLength = ssqInput.pageElements.length;  
	for (var i = 0; i < ssqInput.pageLength; i++) {  
		ssqInput.page[i]= JSON.parse(ssqInput.pageElements[i].dataset.scrollsequence)
		ssqInput.page[i].imagesLength=ssqInput.page[i].imagesFull.length; 
	}	
	//console.log('ssqInput:',ssqInput);
}ssqInputFromPages('.scrollsequence-page');

function ssqInit (){  // User Specific Calculations
	ssqCalc={
		screenHeightInPx:window.innerHeight,
		triggerPosition:window.innerHeight*1, //AKTodo SORT THIS 0 - top 1 bottom 0.5 center
		totalImageNo:0,
		page:[],  
	};
	//1.2 Calculate User/Device Variables for each page
	for (var i = 0; i < ssqInput.pageLength; i++) {  
		ssqCalc.page[i]={}
		ssqCalc.page[i].startPx=(ssqInput.pageElements[i].getBoundingClientRect().top+document.documentElement.scrollTop)-ssqCalc.triggerPosition;  // Aktodo: This could be dynamic 
		ssqCalc.page[i].endPx=(ssqInput.pageElements[i].getBoundingClientRect().bottom+document.documentElement.scrollTop)-ssqCalc.triggerPosition; // Aktodo: This could be dynamic 
		ssqCalc.page[i].durationPx=	ssqCalc.page[i].endPx-ssqCalc.page[i].startPx; // Height in PX for each page 
		ssqCalc.totalImageNo=ssqCalc.totalImageNo+ssqInput.page[i].imagesLength;
	}
}ssqInit();

function ssqCreateCurObject(){ // Create CUR object 
	cur = {};
		for(var i=0; i<ssqInput.pageLength; i++)  {
		   cur[i] = {}; 
		   cur[i] = [i][0];
		   cur[i] = 0;    
		}
  	cur.curPage=0;
  	cur.imagesPreloadedCount=0;	
}ssqCreateCurObject();

function ssqCreateCanvas(){// Create Canvas
	scrollsequenceCanvasElement = document.createElement('canvas');
	scrollsequenceCanvasElement.id="ssqcanvas";
	scrollsequenceCanvasElement.style.position="fixed";
	scrollsequenceCanvasElement.style.zIndex="-1"; 
	//scrollsequenceCanvasElement.style.opacity=ssqInput.imageOpacity; //Aktodo
	scrollsequenceCanvasElement.style.top="0px";
	scrollsequenceCanvasElement.style.left="0px";
	jQuery( "body" ).prepend(scrollsequenceCanvasElement);
	context = document.getElementById("ssqcanvas").getContext("2d");
	console.log('done!!! Calc: ', ssqCalc,'canvas:', scrollsequenceCanvasElement );
}ssqCreateCanvas();

function prepareEmptyImageObjects(){// 5.0 prepare empty image objects
	arrayOfImageObjects =  [];
	for (var i=0; i<ssqInput.pageLength; i++) { 
		  arrayOfImageObjects[i] = [];
		  for (var j = 0; j < ssqInput.page[i].imagesLength; j++) {
		  	arrayOfImageObjects[i]= arrayOfImageObjects[i].concat(new Image());
		  }
	}	
}prepareEmptyImageObjects();
		

function preloadImages(){ // Preload and hide/display
	for (var i=0; i<ssqInput.pageLength; i++) { 
		  for (var j = 0; j < ssqInput.page[i].imagesLength; j++) {
			arrayOfImageObjects[i][j].onload = imageWasLoaded;
		  	arrayOfImageObjects[i][j].src = ssqInput.page[i].imagesFull[j];; // This actually makes the image to be preloaded
		  }
	}
}preloadImages();

function imageWasLoaded(){
	cur.imagesPreloadedCount = cur.imagesPreloadedCount+1;
	if ( cur.imagesPreloadedCount === Math.round(ssqCalc.totalImageNo*ssqInput.preloadPercentage) ){
		jQuery("#scrollsequence-preload-fullpage").fadeOut("slow");
		
	}
}


// --------------------------------------- BELOW IT's MESSY ---------------------


// Render 
function renderCanvas() {   
	var screenDeviceWidth = document.documentElement.clientWidth;
	var screenDeviceHeight = window.innerHeight;
	var screenAspectRatio =  screenDeviceWidth / screenDeviceHeight
	// CSS - Canvas pixel dimensions on screen (=size)
		scrollsequenceCanvasElement.style.width = (screenDeviceWidth*1)+"px";		
		scrollsequenceCanvasElement.style.height =  (screenDeviceHeight*1)+"px"; 
	// CANVAS - How many pixels the canvas has (=quality)
		context.canvas.width = screenDeviceWidth*1;
		context.canvas.height = screenDeviceHeight*1;
	if (screenAspectRatio>=1){ // Panorama aka desktop monitor
		renderScaled(arrayOfImageObjects[cur.curPage][cur[cur.curPage]], ssqInput.page[cur.curPage].scaleTo.desktop, ssqInput.page[cur.curPage].alignX.desktop, ssqInput.page[cur.curPage].alignY.desktop);
	}else{  // Portrait aka mobile screen
		renderScaled(arrayOfImageObjects[cur.curPage][cur[cur.curPage]], ssqInput.page[cur.curPage].scaleTo.mobile, ssqInput.page[cur.curPage].alignX.mobile, ssqInput.page[cur.curPage].alignY.mobile);		
	}			
}
function renderScaled(img, fitOrFill, alignX, alignY){
    var scale, x,y;

	switch (fitOrFill) {
	    case "fill": //FILL
	        scale = Math.max(ssqcanvas.width / img.width, ssqcanvas.height / img.height);
	        break;
	    case "fit": // fit 100 %
	        scale = Math.min(ssqcanvas.width / img.width, ssqcanvas.height / img.height);
	        break;
	    default:  // fit (fitOrFill) %
	        scale = Math.min(ssqcanvas.width / img.width, ssqcanvas.height / img.height)*fitOrFill;
	}
	switch (alignX) {
	    case "left": // Legacy 0.9.93
	        x = 0;
	        break;
	    case "right": // Legacy 0.9.93
			x = (ssqcanvas.width ) - (img.width ) * scale; 
	        break;
	    case "center": // Legacy 0.9.93
			x = (ssqcanvas.width / 2) - (img.width / 2) * scale;
	        break;			        
	    default:
	    	x = (ssqcanvas.width * alignX) - (img.width * alignX) * scale;
	}
	switch (alignY) {
	    case "top": // Legacy 0.9.93
	        y = 0;
	        break;
	    case "bottom": // Legacy 0.9.93
	        y = (ssqcanvas.height ) - (img.height ) * scale;
	        break;
	    case "center": // Legacy 0.9.93
	        y = (ssqcanvas.height / 2) - (img.height / 2) * scale;
	        break;
	    default:
	    	y = (ssqcanvas.height * alignY) - (img.height * alignY) * scale;
	}
	context.drawImage(img, Math.round(x), Math.round(y), Math.ceil(img.width * scale),Math.ceil(img.height * scale)); // math ceil added to avoid sub-pixel rendering
	if (ssqInput.debugSs === '1'){console.log('6 - Render Scaled: ',scale,' x:',x,' alignX:',alignX,' y:',y,' alignY:',alignY);}
}










// 8.0 NO GSAP ANIMATION 
// Render Pages and Elements

// Variables
    let ticking = false;
    let functionRunCounter = 0

// function ssqScrollFunction(scroll_pos) { // Throttled function running on scroll
// 	// COUNTER 	(FYI)
//     	//functionRunCounter = functionRunCounter+1;
//     	//console.log(scroll_pos + "px run count:" + functionRunCounter);
// 	var lastCurImg = cur[cur.curPage]; // store last curImg (so we can look for change)
//     for (var i = 0; i < ssqInput.pageLength; i++) { 
//         if (scroll_pos>= ssqCalc.page[i].startPx && scroll_pos<ssqCalc.page[i].endPx){
//             cur.curPage=i; //  Set Cur Page    
//             var pageProgress = (scroll_pos-ssqCalc.page[i].startPx)/(ssqCalc.page[i].endPx-ssqCalc.page[i].startPx) // Calculate Cur Page  progress 
//             if (ssqInput.debugSs === '1'){console.log('8. pageProgress progress: ',pageProgress)};
//             cur[cur.curPage]=Math.round(pageProgress*(ssqInput.page[i].imagesLength-1)) // update cur.curImg 
//             if (lastCurImg !== cur[cur.curPage]){ // check if cur Image has changed. ONLY if yes => do expensive actions (hide/show + render) 
//             	renderCanvas(); 
//             	//renderPagesAndElements()
//             }
//         } // end of page loop
//     } // end of for loop
// }

/*
*	This function should:
*	1) Update CurPage, CurImg and CurPageProgress
*	2) Either draw the canvas or clear it
*	3) 
*	AkTodo:	
*			- clear correct size of rect 
*	DONE	- requestor: scroll = only draw when new image
*	DONE	- requestor: resize = always draw	 
*				
*/

function ssqScrollPosition(scroll_pos, requestor){ 
	for (var i = 0; i < ssqInput.pageLength; i++) { 
		if (scroll_pos>= ssqCalc.page[i].startPx && scroll_pos<ssqCalc.page[i].endPx){
			var lastCurImg = cur[cur.curPage];// store last curImg (so we can look for change)
			cur.curPage=i;
			cur.pageProgress = (scroll_pos-ssqCalc.page[i].startPx)/(ssqCalc.page[i].endPx-ssqCalc.page[i].startPx) // Calculate Cur Page  progress 
			cur[cur.curPage]=Math.round(cur.pageProgress*(ssqInput.page[i].imagesLength-1)) // update cur.curImg 
			if (requestor === 'scroll') {
				 if (lastCurImg !== cur[cur.curPage]){
				 	console.log('Page:',cur.curPage,'Img (NEW):',cur[cur.curPage],'Progress:', cur.pageProgress.toFixed(3), 'scrollEvent');
				 	return renderCanvas();
				 } else {
				 	console.log('Page:',cur.curPage,'Img:',cur[cur.curPage],'Progress:', cur.pageProgress.toFixed(3), 'scrollEvent');
				 	return;
				 }
			}
			if (requestor === 'resize') {
				console.log('Page:',cur.curPage,'Img:',cur[cur.curPage],'Progress:', cur.pageProgress.toFixed(3), 'resizeEvent');
				return renderCanvas();
			}
		}
	} // end of for loop
	return context.clearRect(0,0,4000000,4000000); //AKTodo - use real size!!!
}

window.addEventListener('scroll', function(e) { // Scroll Listener (no throttle, fires like mad)
  if (!ticking) {
    window.requestAnimationFrame(function() {
      ssqScrollPosition(window.scrollY,'scroll');
      ticking = false;
    });
    ticking = true;
  }
});

window.addEventListener('resize', function(e) { // Resize Listener (no throttle, fires like mad)
  if (!ticking) {
    window.requestAnimationFrame(function() {
      ssqScrollPosition(window.scrollY,'resize');
      ticking = false;
    });
    ticking = true;
  }
});

})();  // Close IIFE